package beatport.jsonpojo;

/**
 * 
 * @author Richard Vogl <richard.vogl@jku.at>
 * 
 * License: CreativeCommons Attribution-NonCommercial-ShareAlike 4.0 International
 * http://creativecommons.org/licenses/by-nc-sa/4.0/
 *
 */

import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

@JsonIgnoreProperties(ignoreUnknown = true)
public class Entry {
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Boolean getActive() {
		return active;
	}

	public void setActive(Boolean active) {
		this.active = active;
	}

	public String getMixName() {
		return mixName;
	}

	public void setMixName(String mixName) {
		this.mixName = mixName;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getSlug() {
		return slug;
	}

	public void setSlug(String slug) {
		this.slug = slug;
	}

	public String getReleaseDate() {
		return releaseDate;
	}

	public void setReleaseDate(String releaseDate) {
		this.releaseDate = releaseDate;
	}

	public String getPublishDate() {
		return publishDate;
	}

	public void setPublishDate(String publishdate) {
		this.publishDate = publishdate;
	}

	public String getSampleUrl() {
		return sampleUrl;
	}

	public void setSampleUrl(String sampleUrl) {
		this.sampleUrl = sampleUrl;
	}

	public Boolean getIsPreviewAvailable() {
		return isPreviewAvailable;
	}

	public void setIsPreviewAvailable(Boolean isPreviewAvailable) {
		this.isPreviewAvailable = isPreviewAvailable;
	}

	public String getRtmpStreamUrl() {
		return rtmpStreamUrl;
	}

	public void setRtmpStreamUrl(String rtmpStreamUrl) {
		this.rtmpStreamUrl = rtmpStreamUrl;
	}

	public Boolean getExclusive() {
		return exclusive;
	}

	public void setExclusive(Boolean exclusive) {
		this.exclusive = exclusive;
	}

	public Previews getPreview() {
		return preview;
	}

	public void setPreview(Previews preview) {
		this.preview = preview;
	}

	public Price getPrice() {
		return price;
	}

	public void setPrice(Price price) {
		this.price = price;
	}

	public Boolean getPurchasable() {
		return purchasable;
	}

	public void setPurchasable(Boolean purchasable) {
		this.purchasable = purchasable;
	}

	public String getLength() {
		return length;
	}

	public void setLength(String length) {
		this.length = length;
	}

	public long getLengthMs() {
		return lengthMs;
	}

	public void setLengthMs(long lengthMs) {
		this.lengthMs = lengthMs;
	}

	public Double getBpm() {
		return bpm;
	}

	public void setBpm(Double bpm) {
		this.bpm = bpm;
	}

	public Key getKey() {
		return key;
	}

	public void setKey(Key key) {
		this.key = key;
	}

	public String getSaleType() {
		return saleType;
	}

	public void setSaleType(String saleType) {
		this.saleType = saleType;
	}

	public List<Artist> getArtists() {
		return artists;
	}

	public void setArtists(List<Artist> artists) {
		this.artists = artists;
	}

	public List<Genre> getGenres() {
		return genres;
	}

	public void setGenres(List<Genre> genres) {
		this.genres = genres;
	}

	public Release getRelease() {
		return release;
	}

	public void setRelease(Release release) {
		this.release = release;
	}

	public Label getLabel() {
		return label;
	}

	public void setLabel(Label label) {
		this.label = label;
	}

	private String id;
	private String type;
	private String name;
	private Boolean active;
	private String mixName;
	private String title;
	private String slug;
	private String releaseDate;
	private String publishDate;
	private String sampleUrl;
	private Boolean isPreviewAvailable;
	private String rtmpStreamUrl;
	private Boolean exclusive;
	private Previews preview;
	private Price price;
	private Boolean purchasable;
	private String length;
	private long lengthMs;
	private Double bpm;
	private Key key;
	private String saleType;
	private List<Artist> artists;
	private List<Genre> genres;
	private Release release;
	private Label label;
}
