/*
 * Created on 21.02.2005
 *
 */
package cp.text;

/**
 * 
 * @author Peter Knees <peter.knees@jku.at>
 * 
 * License: CreativeCommons Attribution-NonCommercial-ShareAlike 4.0 International
 * http://creativecommons.org/licenses/by-nc-sa/4.0/
 *
 */


import java.util.Hashtable;


/**
 * @author Peter Knees
 *
 */
public class HTMLCharacters {
	private static Hashtable<String, String> charcodes;

	static {
		charcodes = new Hashtable<String, String>();
		
		charcodes.put("&#09;", "\t");//     Horizontal tab
		charcodes.put("&#10;", "\n");//     Line feed
		charcodes.put("&#13;", "\n");//     Carriage Return
		charcodes.put("&#32;", " ");//     Space
		charcodes.put("&#33;", "!");//     Exclamation mark
		charcodes.put("&#34;", "\"");//     Quotation mark
		charcodes.put("&quot;", "\"");
		charcodes.put("&#35;", "#");//     Number sign
		charcodes.put("&#36;", "$");//     Dollar sign
		charcodes.put("&#37;", "%");//     Percent sign
		charcodes.put("&#38;", "&");//     Ampersand
		charcodes.put("&amp;", "&");
		charcodes.put("&#39;", "'");//     Apostrophe
		charcodes.put("&#039;", "'");//    Apostrophe
		charcodes.put("&#40;", "(");//     Left parenthesis
		charcodes.put("&#41;", ")");//     Right parenthesis
		charcodes.put("&#42;", "*");//     Asterisk
		charcodes.put("&#43;", "+");//     Plus sign
		charcodes.put("&#44;", ",");//     Comma
		charcodes.put("&#45;", "-");//     Hyphen
		charcodes.put("&#46;", ".");//     Period (fullstop)
		charcodes.put("&#47;", "/");//     Solidus (slash)
		
		charcodes.put("&#48;", "0");
		charcodes.put("&#49;", "1");
		charcodes.put("&#50;", "2");
		charcodes.put("&#51;", "3");
		charcodes.put("&#52;", "4");
		charcodes.put("&#53;", "5");
		charcodes.put("&#54;", "6");
		charcodes.put("&#55;", "7");
		charcodes.put("&#56;", "8");
		charcodes.put("&#57;", "9");
		
		charcodes.put("&#58;", ":");//     Colon
		charcodes.put("&#59;", ";");//     Semi-colon
		charcodes.put("&#60;", "[");//     Less than
		charcodes.put("&lt;", "[");
		charcodes.put("&#61;", "=");//     Equals sign
		charcodes.put("&#62;", "]");//     Greater than
		charcodes.put("&gt;", "]");
		charcodes.put("&#63;", "?");//     Question mark
		charcodes.put("&#64;", "@");//     Commercial at
		
		charcodes.put("&#65;", "A");
		charcodes.put("&#66;", "B"); 
		charcodes.put("&#67;", "C"); 
		charcodes.put("&#68;", "D"); 
		charcodes.put("&#69;", "E"); 
		charcodes.put("&#70;", "F"); 
		charcodes.put("&#71;", "G"); 
		charcodes.put("&#72;", "H"); 
		charcodes.put("&#73;", "I"); 
		charcodes.put("&#74;", "J"); 
		charcodes.put("&#75;", "K"); 
		charcodes.put("&#76;", "L"); 
		charcodes.put("&#77;", "M"); 
		charcodes.put("&#78;", "N"); 
		charcodes.put("&#79;", "O"); 
		charcodes.put("&#80;", "P"); 
		charcodes.put("&#81;", "Q"); 
		charcodes.put("&#82;", "R"); 
		charcodes.put("&#83;", "S"); 
		charcodes.put("&#84;", "T"); 
		charcodes.put("&#85;", "U"); 
		charcodes.put("&#86;", "V"); 
		charcodes.put("&#87;", "W"); 
		charcodes.put("&#88;", "X"); 
		charcodes.put("&#89;", "Y"); 
		charcodes.put("&#90;", "Z");
		
		charcodes.put("&#91;", "[");//     Left square bracket
		charcodes.put("&#92;", "\\");//     Reverse solidus (backslash)
		charcodes.put("&#93;", "]");//     Right square bracket
		charcodes.put("&#94;", "^");//     Caret
		charcodes.put("&#95;", "-");//     Horizontal bar (underscore) _
		charcodes.put("&#96;", "'");//     Acute accent
		
		charcodes.put("&#97;", "a");
		charcodes.put("&#98;", "b");
		charcodes.put("&#99;", "c");
		charcodes.put("&#100;", "d");
		charcodes.put("&#101;", "e");
		charcodes.put("&#102;", "f");
		charcodes.put("&#103;", "g");
		charcodes.put("&#104;", "h");
		charcodes.put("&#105;", "i");
		charcodes.put("&#106;", "j");
		charcodes.put("&#107;", "k");
		charcodes.put("&#108;", "l");
		charcodes.put("&#109;", "m");
		charcodes.put("&#110;", "n");
		charcodes.put("&#111;", "o");
		charcodes.put("&#112;", "p");
		charcodes.put("&#113;", "q");
		charcodes.put("&#114;", "r");
		charcodes.put("&#115;", "s");
		charcodes.put("&#116;", "t");
		charcodes.put("&#117;", "u");
		charcodes.put("&#118;", "v");
		charcodes.put("&#119;", "w");
		charcodes.put("&#120;", "x");
		charcodes.put("&#121;", "y");
		charcodes.put("&#122;", "z");
		
		charcodes.put("&#123;", "[");//   Left curly brace
		charcodes.put("&#124;", "|");//   Vertical bar
		charcodes.put("&#125;", "]");//   Right curly brace
		charcodes.put("&#126;", "~");//   Tilde
		
		charcodes.put("&#160;", " ");//   Non-breaking Space
		charcodes.put("&nbsp;", " ");
		charcodes.put("&#161;", "¡");//   Inverted exclamation ¡
		charcodes.put("&iexcl;", "¡");
		charcodes.put("&#162;", "cent");//   Cent sign ¢
		charcodes.put("&cent;", "cent");
		charcodes.put("&#163;", "Pound");//   Pound sterling £
		charcodes.put("&pound;", "Pound");
		charcodes.put("&#164;", "Euro");//   General currency sign €
		charcodes.put("&curren;", "Euro");
		charcodes.put("&#165;", "Yen");//   Yen sign ¥
		charcodes.put("&yen;", "Yen");
		charcodes.put("&#166;", " ");//   Broken vertical bar Š
		charcodes.put("&brvbar;", " ");
		charcodes.put("&#167;", "§");//   Section sign §
		charcodes.put("&sect;", "§");
		charcodes.put("&#168;", " ");//   Umlaut (dieresis) š
		charcodes.put("&uml;", " ");
		charcodes.put("&#169;", "(C)");//   Copyright ©
		charcodes.put("&copy;", "(C)");
		charcodes.put("&#170;", "a");//   Feminine ordinal ª
		charcodes.put("&ordf;", "a");
		charcodes.put("&#171;", "[");//   Left angle quote, guillemotleft «
		charcodes.put("&laquo;", "[");
		charcodes.put("&#172;", "-");//   Not sign ¬
		charcodes.put("&not;", "-");
		charcodes.put("&#173;", "-");//   Soft hyphen ­
		charcodes.put("&shy;", "-");
		charcodes.put("&#174;", "(R)");//   Registered trademark ®
		charcodes.put("&reg;", "(R)");
		charcodes.put("&#175;", "-");//   Macron accent ¯
		charcodes.put("&macr;", "-");
		charcodes.put("&#176;", "°");//   Degree sign
		charcodes.put("&deg;", "°");
		charcodes.put("&#177;", "-");//   Plus or minus ±
		charcodes.put("&plusmn;", "-");
		charcodes.put("&#178;", "2");//   Superscript two ²
		charcodes.put("&sup2;", "2");
		charcodes.put("&#179;", "3");//   Superscript three ³
		charcodes.put("&sup3;", "3");
		charcodes.put("&#180;", "'");//   Acute accent Ž
		charcodes.put("&acute;", "'");
		charcodes.put("&#181;", "m");//   Micro sign µ
		charcodes.put("&micro;", "m");
		charcodes.put("&#182;", " ");//   Paragraph sign ¶
		charcodes.put("&para;", " ");
		charcodes.put("&#183;", " ");//   Middle dot ·
		charcodes.put("&middot;", " ");
		charcodes.put("&cedil;", " ");//   Cedilla 
		charcodes.put("&#184;", " ");
		charcodes.put("&sup1;", "1");//   Superscript one ¹
		charcodes.put("&#185;", "1");
		charcodes.put("&ordm;", "o");//   Masculine ordinal º
		charcodes.put("&#186;", "o");
		charcodes.put("&raquo;", "]");//   Right angle quote, guillemotright
		charcodes.put("&#187;", "]");
		charcodes.put("&rsquo;", "'");
		charcodes.put("&lsquo;", "'");
		charcodes.put("&frad14;", "0.25");//   Fraction one-fourth Œ
		charcodes.put("&#188;", "0.25");
		charcodes.put("&frac12;", "0.5");//   Fraction one-half œ
		charcodes.put("&#189;", "0.5");
		charcodes.put("&#190;", "0.75");//   Fraction three-fourths Ÿ
		charcodes.put("&frac34;", "0.75");
		charcodes.put("&#191;", "¿");//   Inverted question mark
		charcodes.put("&iquest;", "¿");
		charcodes.put("&#192;", "À");//   Capital A, grave accent
		charcodes.put("&Agrave;", "À");
		charcodes.put("&#193;", "Á");//   Capital A, acute accent
		charcodes.put("&Aacute;", "Á");
		charcodes.put("&#194;", "Â");//   Capital A, circumflex accent
		charcodes.put("&Acirc;", "Â");
		charcodes.put("&#195;", "Ã");//   Capital A, tilde
		charcodes.put("&Atilde;", "Ã");
		charcodes.put("&#196;", "Ä");//   Capital A, dieresis or umlaut mark
		charcodes.put("&Auml;", "Ä");
		charcodes.put("&#197;", "Å");//   Capital A, ring
		charcodes.put("&Aring;", "Å");
		charcodes.put("&#198;", "Æ");//   Capital AE dipthong (ligature)
		charcodes.put("&AElig;", "Æ");
		charcodes.put("&#199;", "Ç");//   Capital C, cedilla
		charcodes.put("&Ccedil;", "Ç");
		charcodes.put("&#200;", "È");//   Capital E, grave accent
		charcodes.put("&Egrave;", "È");
		charcodes.put("&#201;", "É");//   Capital E, acute accent
		charcodes.put("&Eacute;", "É");
		charcodes.put("&#202;", "Ê");//   Capital E, circumflex accent
		charcodes.put("&Ecirc;", "Ê");
		charcodes.put("&#203;", "Ë");//   Capital E, dieresis or umlaut mark
		charcodes.put("&Euml;", "Ë");
		charcodes.put("&#204;", "Ì");//   Capital I, grave accent
		charcodes.put("&Igrave;", "Ì");
		charcodes.put("&#205;", "Í");//   Capital I, acute accent
		charcodes.put("&Iacute;", "Í");
		charcodes.put("&#206;", "Î");//   Capital I, circumflex accent
		charcodes.put("&Icirc;", "Î");
		charcodes.put("&#207;", "Ï");//   Capital I, dieresis or umlaut mark
		charcodes.put("&Iuml;", "Ï");
		charcodes.put("&#208;", "Ð");//   Capital Eth, Icelandic
		charcodes.put("&ETH;", "Ð");
		charcodes.put("&#209;", "Ñ");//   Capital N, tilde
		charcodes.put("&Ntilde;", "Ñ");
		charcodes.put("&#210;", "Ò");//   Capital O, grave accent
		charcodes.put("&Ograve;", "Ò");
		charcodes.put("&#211;", "Ó");//   Capital O, acute accent
		charcodes.put("&Oacute;", "Ó");
		charcodes.put("&#212;", "Ô");//   Capital O, circumflex accent
		charcodes.put("&Ocirc;", "Ô");
		charcodes.put("&#213;", "Õ");//   Capital O, tilde
		charcodes.put("&Otilde;", "Õ");
		charcodes.put("&#214;", "Ö");//   Capital O, dieresis or umlaut mark
		charcodes.put("&Ouml;", "Ö");
		charcodes.put("&#215;", "x");//   Multiply sign ×
		charcodes.put("&times;", "x");
		charcodes.put("&#216;", "Ø");//   Capital O, slash
		charcodes.put("&Oslash;", "Ø");
		charcodes.put("&#217;", "Ù");//   Capital U, grave accent
		charcodes.put("&Ugrave;", "Ù");
		charcodes.put("&#218;", "Ú");//   Capital U, acute accent
		charcodes.put("&Uacute;", "Ú");
		charcodes.put("&#219;", "Û");//   Capital U, circumflex accent
		charcodes.put("&Ucirc;", "Û");
		charcodes.put("&#220;", "Ü");//   Capital U, dieresis or umlaut mark
		charcodes.put("&Uuml;", "Ü");
		charcodes.put("&#221;", "Ý");//   Capital Y, acute accent
		charcodes.put("&Yacute;", "Ý");
		charcodes.put("&#222;", "Þ");//   Capital THORN, Icelandic
		charcodes.put("&THORN;", "Þ");
		charcodes.put("&#223;", "ß");//   Small sharp s, German (sz ligature)
		charcodes.put("&szlig;", "ß");
		charcodes.put("&#224;", "à");//   Small a, grave accent
		charcodes.put("&agrave;", "à"); 
		charcodes.put("&#225;", "á");//   Small a, acute accent
		charcodes.put("&aacute;", "á");
		charcodes.put("&#226;", "â");//   Small a, circumflex accent
		charcodes.put("&acirc;", "â");
		charcodes.put("&#227;", "ã");//   Small a, tilde
		charcodes.put("&atilde;", "ã");
		charcodes.put("&#228;", "ä");//   Small a, dieresis or umlaut mark
		charcodes.put("&auml;", "ä");
		charcodes.put("&#229;", "å");//   Small a, ring
		charcodes.put("&aring;", "å");
		charcodes.put("&#230;", "æ");//   Small ae dipthong (ligature)
		charcodes.put("&aelig;", "æ");
		charcodes.put("&#231;", "ç");//   Small c, cedilla
		charcodes.put("&ccedil;", "ç");
		charcodes.put("&#232;", "è");//   Small e, grave accent
		charcodes.put("&egrave;", "è");
		charcodes.put("&#233;", "é");//   Small e, acute accent
		charcodes.put("&eacute;", "é");
		charcodes.put("&#234;", "ê");//   Small e, circumflex accent
		charcodes.put("&ecirc;", "ê");
		charcodes.put("&#235;", "ë");//   Small e, dieresis or umlaut mark
		charcodes.put("&euml;", "ë");
		charcodes.put("&#236;", "ì");//   Small i, grave accent
		charcodes.put("&igrave;", "ì");
		charcodes.put("&#237;", "í");//   Small i, acute accent
		charcodes.put("&iacute;", "í");
		charcodes.put("&#238;", "î");//   Small i, circumflex accent
		charcodes.put("&icirc;", "î");
		charcodes.put("&#239;", "ï");//   Small i, dieresis or umlaut mark
		charcodes.put("&iuml;", "ï");
		charcodes.put("&#240;", "ð");//   Small eth, Icelandic
		charcodes.put("&eth;", "ð");
		charcodes.put("&#241;", "ñ");//   Small n, tilde
		charcodes.put("&ntilde;", "ñ");
		charcodes.put("&#242;", "ò");//   Small o, grave accent
		charcodes.put("&ograve;", "ò");
		charcodes.put("&#243;", "ó");//   Small o, acute accent
		charcodes.put("&oacute;", "ó");
		charcodes.put("&#244;", "ô");//   Small o, circumflex accent
		charcodes.put("&ocirc;", "ô");
		charcodes.put("&#245;", "õ");//   Small o, tilde
		charcodes.put("&otilde;", "õ");
		charcodes.put("&#246;", "ö");//   Small o, dieresis or umlaut mark
		charcodes.put("&ouml;", "ö");
		charcodes.put("&#247;", "/");//   Division sign ÷
		charcodes.put("&divide;", "/");
		charcodes.put("&#248;", "ø");//   Small o, slash
		charcodes.put("&oslash;", "ø");
		charcodes.put("&#249;", "ù");//   Small u, grave accent
		charcodes.put("&ugrave;", "ù");
		charcodes.put("&#250;", "ú");//   Small u, acute accent
		charcodes.put("&uacute;", "ú");
		charcodes.put("&#251;", "û");//   Small u, circumflex accent
		charcodes.put("&ucirc;", "û");
		charcodes.put("&#252;", "ü");//   Small u, dieresis or umlaut mark
		charcodes.put("&uuml;", "ü");
		charcodes.put("&#253;", "ý");//   Small y, acute accent
		charcodes.put("&yacute;", "ý");
		charcodes.put("&#254;", "þ");//   Small thorn, Icelandic
		charcodes.put("&thorn;", "þ");
		charcodes.put("&#255;", "ÿ");//   Small y, dieresis or umlaut mark
		charcodes.put("&yuml;", "ÿ");
		
		charcodes.put("&#8211;", "-");
		charcodes.put("&#8212;", "-");
		charcodes.put("&#8217;", "'");
		charcodes.put("&#8250;", "-");
	}
	
	public static Hashtable<String, String> getHTMLHashtable() {
		return charcodes;
	}
	
	public static String toBasicString(String s) {
		return toBasicString(s, "");
	}
	
	public static String toBasicString(String s, String additionalChars) {
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<s.length(); i++) {
			char c = s.toLowerCase().charAt(i);
			if ("abcdefghijklmnopqrstuvwxyz0123456789 ".indexOf(c+"")!=-1)
				sb.append(c);
			else if (additionalChars.indexOf(c+"")!=-1)
				sb.append(c);
			else if ("àáâãäåæ".indexOf(c+"")!=-1)
				sb.append('a');
			else if ("ç".indexOf(c+"")!=-1)
				sb.append('c');
			else if ("èéêëð".indexOf(c+"")!=-1)
				sb.append('e');
			else if ("ìíîï".indexOf(c+"")!=-1)
				sb.append('i');
			else if ('ñ'==c)
				sb.append('n');
			else if ("òóôõöø".indexOf(c+"")!=-1)
				sb.append('o');
			else if ("ùúûü".indexOf(c+"")!=-1)
				sb.append('u');
			else if ("ÿý".indexOf(c+"")!=-1)
				sb.append('y');
			else if ('ß'==c)
				sb.append("ss");
		}
		return sb.toString();
	}
}
